package ${basePackage}.action.ajax.system;

import com.fasterxml.jackson.core.TreeNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.multipart.MultipartFile;
import ${basePackage}.frame.excel.WSheet;
import ${basePackage}.frame.utils.LogUtil;
import ${basePackage}.frame.auth.LocalData;
import ${basePackage}.frame.base.ErrorType;
import ${basePackage}.frame.utils.MapperUtil;
import ${basePackage}.frame.base.BaseResponse;
import ${basePackage}.frame.utils.ResponseUtil;
import ${basePackage}.frame.utils.ValidationUtil;
import ${basePackage}.frame.excel.exception.ReadErrorException;
import ${basePackage}.frame.excel.exception.TemplateNotMatchException;
import ${basePackage}.module.system.ent.UserRole;
import ${basePackage}.module.system.mgr.UserRoleManager;
import ${basePackage}.module.system.req.UserRoleCreateRequest;
import ${basePackage}.module.system.req.UserRoleDeleteRequest;
import ${basePackage}.module.system.req.UserRoleFindRequest;
import ${basePackage}.module.system.req.UserRoleGetRequest;
import ${basePackage}.module.system.req.UserRoleUpdateRequest;
import ${basePackage}.module.system.rsp.UserRoleCreateResponse;
import ${basePackage}.module.system.rsp.UserRoleDeleteResponse;
import ${basePackage}.module.system.rsp.UserRoleFindResponse;
import ${basePackage}.module.system.rsp.UserRoleGetResponse;
import ${basePackage}.module.system.rsp.UserRoleUpdateResponse;

import java.io.IOException;
import java.util.List;

public class UserRoleAjax{

    @Autowired
    private UserRoleManager userRoleManager;

    public UserRoleCreateResponse create(UserRoleCreateRequest request) {
        return userRoleManager.create(request, LocalData.getToken());
    }

    public UserRoleDeleteResponse delete(UserRoleDeleteRequest request) {
        return userRoleManager.delete(request, LocalData.getToken());
    }

    public UserRoleUpdateResponse update(UserRoleUpdateRequest request) {
        return userRoleManager.update(request, LocalData.getToken());
    }

    public UserRoleFindResponse find(UserRoleFindRequest request) {
        return userRoleManager.find(request, LocalData.getToken());
    }

    public UserRoleGetResponse get(UserRoleGetRequest request) {
        return userRoleManager.get(request, LocalData.getToken());
    }
}
