package ${basePackage}.module.system.mgr;

import ${basePackage}.frame.base.Token;
import ${basePackage}.module.system.req.RoleResourceCreateRequest;
import ${basePackage}.module.system.req.RoleResourceDeleteRequest;
import ${basePackage}.module.system.req.RoleResourceFindRequest;
import ${basePackage}.module.system.req.RoleResourceGetRequest;
import ${basePackage}.module.system.req.RoleResourceUpdateRequest;
import ${basePackage}.module.system.rsp.RoleResourceCreateResponse;
import ${basePackage}.module.system.rsp.RoleResourceDeleteResponse;
import ${basePackage}.module.system.rsp.RoleResourceFindResponse;
import ${basePackage}.module.system.rsp.RoleResourceGetResponse;
import ${basePackage}.module.system.rsp.RoleResourceUpdateResponse;

/**
 * 角色资源关系
 *
 * @author wangbing
 * @version 0.0.1
 * @since 2017-01-01
 */
public interface RoleResourceManager {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    RoleResourceCreateResponse create(RoleResourceCreateRequest request, Token token);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    RoleResourceDeleteResponse delete(RoleResourceDeleteRequest request, Token token);

    /**
     * 更新
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    RoleResourceUpdateResponse update(RoleResourceUpdateRequest request, Token token);

    /**
     * 查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    RoleResourceFindResponse find(RoleResourceFindRequest request, Token token);

    /**
     * 获得对象
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    RoleResourceGetResponse get(RoleResourceGetRequest request, Token token);
}
