package ${basePackage}.module.system.req;

import ${basePackage}.frame.base.BaseRequest;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.NotEmpty;
import org.hibernate.validator.constraints.Length;
import ${basePackage}.frame.validation.Dict;

/**
 * ResourceCreateRequest - 资源新增
 *
 * @author wangbing
 * @version 0.0.1
 * @since 2019-12-27
 */
public class ResourceCreateRequest extends BaseRequest {

    /**
     * 资源代码
     */
    @NotEmpty(message = "[code]资源代码不能为空")
    @Length(min = 0, max = 50, message = "[code]资源代码长度不合法(0-50)")
    private String code;

    /**
     * 资源内容
     */
    @NotEmpty(message = "[value]资源内容不能为空")
    @Length(min = 0, max = 100, message = "[value]资源内容长度不合法(0-100)")
    private String value;

    /**
     * 资源描述
     */
    @Length(min = 0, max = 255, message = "[comment]资源描述长度不合法(0-255)")
    private String comment;

    /**
     * 资源类型
     */
    @NotNull(message = "[resourceType]资源类型不能为NULL")
    @Dict(name = "RESOURCE_TYPE")
    private String resourceType;

    /**
     * 是否有效
     */
    @NotNull(message = "[valid]是否有效不能为NULL")
    private Boolean valid;

    public String getCode() {
        return this.code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getValue() {
        return this.value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getComment() {
        return this.comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public String getResourceType() {
        return this.resourceType;
    }

    public void setResourceType(String resourceType) {
        this.resourceType = resourceType;
    }

    public Boolean getValid() {
        return this.valid;
    }

    public void setValid(Boolean valid) {
        this.valid = valid;
    }
}
