<div id="app" v-cloak>
    <el-card class="box-card search">
        <el-form :inline="true" :model="vm" ref="vm" label-position="right" label-width="90px">
            <el-form-item label="角色代码" prop="code">
                <el-input v-model="vm.code" clearable size="small" placeholder="请输入角色代码"></el-input>
            </el-form-item>
            <el-form-item label="角色名称" prop="name">
                <el-input v-model="vm.name" clearable size="small" placeholder="请输入角色名称"></el-input>
            </el-form-item>
            <el-form-item label="角色描述" prop="comment">
                <el-input v-model="vm.comment" clearable size="small" placeholder="请输入角色描述"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="small" icon="el-icon-search" @click="onSearch">搜索</el-button>
                <el-button type="warning" size="small" icon="el-icon-refresh-left" @click="onReset('vm')">重置</el-button>
            </el-form-item>
        </el-form>
    </el-card>

    <el-card class="box-card data">
        <el-row>
            <el-col :span="12">
                <el-button type="success" size="small" icon="el-icon-plus" @click="onCreate">新增</el-button>

                <el-button type="warning" size="small" icon="el-icon-download" @click="onExport">导出</el-button>

                <el-dialog class="form" :title="form.title" :visible.sync="form.dialog">
                    <el-form :model="form" :inline="true" :rules="formRules" ref="form" label-position="right" label-width="90px">
                        <el-form-item label="角色代码" prop="code">
                            <el-input v-model="form.code" clearable size="small" placeholder="请输入角色代码"></el-input>
                        </el-form-item>
                        <el-form-item label="角色名称" prop="name">
                            <el-input v-model="form.name" clearable size="small" placeholder="请输入角色名称"></el-input>
                        </el-form-item>
                        <el-form-item label="角色描述" prop="comment">
                            <el-input v-model="form.comment" clearable size="small" placeholder="请输入角色描述"></el-input>
                        </el-form-item>
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button size="small" @click="form.dialog = false">取 消</el-button>
                        <el-button size="small" type="primary" @click="onSave">保存</el-button>
                    </span>
                </el-dialog>
            </el-col>

            <el-col :span="12">
                <el-button-group style="float: right;">
                    <el-tooltip effect="dark" content="Excel模板下载" placement="bottom">
                        <el-button size="small" icon="el-icon-date" @click="onTemplate"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="Excel导入" placement="bottom">
                        <el-button size="small" icon="el-icon-upload2" @click="onImport"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="批量删除" placement="bottom">
                        <el-button size="small" icon="el-icon-delete" @click="onBitchDelete"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="刷新" placement="bottom">
                        <el-button size="small" icon="el-icon-refresh" @click="onFind"></el-button>
                    </el-tooltip>
                </el-button-group>
            </el-col>
        </el-row>

        <el-table
                @selection-change="onSelectionChange"
                empty-text="无数据"
                :data="result"
                size="mini">
            <el-table-column
                    align="center"
                    type="selection"
                    width="40">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="id"
                    label="主键"
                    width="140">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="code"
                    label="角色代码">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="name"
                    label="角色名称">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="comment"
                    label="角色描述">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="createTime"
                    width="140"
                    label="创建时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    fixed="right"
                    width="120"
                    label="操作">
                <template slot-scope="scope">
                    <el-dropdown size="mini" split-button type="primary" @click="onCommand(['edit',scope.row])"
                                 @command="onCommand">
                        <i class="el-icon-edit"></i>编辑
                        <el-dropdown-menu slot="dropdown">
                            <el-dropdown-item :command="['delete',scope.row]" icon="el-icon-delete">删除
                            </el-dropdown-item>
                        </el-dropdown-menu>
                    </el-dropdown>
                </template>
            </el-table-column>
        </el-table>

        <el-pagination
                background
                v-if="vm.totalCount > vm.pageSize"
                style="margin-top: 10px"
                @current-change="onPage"
                :current-page="vm.pageNumber"
                :page-size="vm.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="vm.totalCount">
        </el-pagination>
    </el-card>
</div>
<script>
    var app = new Vue({
        mixins: [mixin],
        el: "#app",
        data: {
            module: 'system',
            target: 'role',
            vm: {//条件及分页参数
                code: "",
                name: "",
                comment: "",
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0,
                sortKey:'CREATE_TIME',
                sortType:'DESC'
            },
            form: {//待提交表单
                title: "",
                dialog: false,
                id: '',
                code: "",
                name: "",
                comment: "",
                rowVersion: ""
            },
            formRules: {
                code: [
                    {required: true, message: '角色代码不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '角色代码长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                name: [
                    {required: true, message: '角色名称不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '角色名称长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                comment: [
                    {min: 1, max: 50, message: '角色描述长度在 1 到 50 个字符', trigger: 'blur'}
                ],
            }
        },
        methods: {
            onCreate: function () {
                this.form.title = "角色新增";
                this.form.dialog = true;
                this.form.id = "";
                this.form.code = "";
                this.form.name = "";
                this.form.comment = "";
            },
            onCommand: function (arg) {
                const cmd = arg[0];
                const item = arg[1];
                switch (cmd) {
                    case "edit":
                        this.form.title = "角色编辑";
                        this.form.dialog = true;
                        this.form.id = item.id;
                        this.form.code = item.code;
                        this.form.name = item.name;
                        this.form.comment = item.comment;
                        this.form.rowVersion = item.rowVersion;
                        break;
                    case "delete":
                        this.onDelete(item);
                        break;
                    default:
                        this.w("未找到对应的命令");
                        break;
                }
            },
        },
        mounted: function () {
            this.onFind();
        },
    })
</script>
